{----------------------------------------------------------------------------}
{                                                                            }
{                       ULTRA CORECTOR Version 2.1                           }
{                 Copyright (C) 1994-95 By The GodFather                     }
{                                                                            }
{----------------------------------------------------------------------------}
{                       Last corection - 17 July 1995                        }
{----------------------------------------------------------------------------}

{$M, 16380, 0, 655360}

USES
  Crt, Objects, Keybord, Screen, Windows, Buttons, Corector;

CONST
  _I    = '  ';
  Lifes = '';
  PassW = '';
  Live  = '';
  Every = '';
  Money = '';
  Enrgy = '';
  Bull  = '';
  Shild = '';
  Magic = '';
  Balls = '';
  Bombs = '';
  LAndB = '  ';

  AirborneRanger = 1;
  Aladdin        = 2;
  Arcanoid1      = 3;
  Arcanoid2      = 4;
  ArcticAd1      = 5;
  AvoidTheNoid   = 6;
  BadStreet      = 7;
  BattleChess1   = 8;
  BattleChess4   = 9;
  BioMenace1     = 10;
  BlakeStone     = 11;
  BubbleBobble   = 12;
  Bushido        = 13;
  Cat            = 14;
  Catacombs3D    = 15;
  CdMan          = 16;
  Civilization   = 17;
  ClydesAdvent   = 18;
  CommanderKeen1 = 19;
  CommanderKeen2 = 20;
  CommanderKeen3 = 21;
  CommanderKeen4 = 22;
  CommanderKeen5 = 23;
  CommanderKeen6 = 24;
  CKeen6Pass     = 25;
  CKeen6DemoVer  = 26;
  CrimeWave      = 27;
  CrusadersOf    = 28;
  CrystalCaves1  = 29;
  DIF2           = 30;
  DangerousDave1 = 31;
  DangerousDave2 = 32;
  DarkAges1      = 33;
  DawnRider      = 34;
  DeathBringer   = 35;
  DieHard        = 36;
  Dogfight       = 37;
  DoubleDragon1  = 38;
  DoubleDragon2  = 39;
  DoubleDragon3  = 40;
  DragonStrike   = 41;
  DuckTales      = 42;
  DukeNukem1     = 43;
  DukeNukem3     = 44;
  Dune2          = 45;
  DynaBlaster    = 46;
  EyeOfTheBe1    = 47;
  F117A          = 48;
  F15StrikeEag3  = 49;
  F19Stealth     = 50;
  FlashBack      = 51;
  Formula1GP     = 52;
  Fury           = 53;
  Galactix1      = 54;
  Gauntlet2      = 55;
  Gods           = 56;
  GoldenAxe      = 57;
  GrandPrixU     = 58;
  Gremlins2      = 59;
  GunShip2000    = 60;
  Harald         = 61;
  HardHatMack    = 62;
  Harrier        = 63;
  HeroesOfTheL   = 64;
  HocusPocus     = 65;
  Indiana500     = 66;
  IntoTheEagle   = 67;
  Ironman        = 68;
  Jazz_Shareware = 69;
  JumpMan        = 70;
  Karateka       = 71;
  LHXAttackC     = 72;
  Lotus3         = 73;
  Luigi          = 74;
  MajorStriker   = 75;
  MechWarrior    = 76;
  MegaloMania    = 77;
  Menace         = 78;
  MonsterBash1   = 79;
  MoonStone      = 80;
  Motocross      = 81;
  NBA            = 82;
  OutRun_CGA     = 83;
  PacMan         = 84;
  Pila           = 85;
  PinballDream   = 86;
  Popcorn        = 87;
  Predator2      = 88;
  RailroadTycoon = 89;
  Raptor         = 90;
  RealmsOfChaos  = 91;
  RexNebular     = 92;
  RickDangerous2 = 93;
  Rocketeer      = 94;
  SecretAgent1   = 95;
  SecretWeapons  = 96;
  ShadowKnights  = 97;
  SimCity        = 98;
  SimCity2000    = 99;
  SimCityPass    = 100;
  SimEarth       = 101;
  SpecialForces  = 102;
  StormLordCGA   = 103;
  StormLordVGA   = 104;
  StreetRod      = 105;
  StreetRod2     = 106;
  StripPoker3    = 107;
  SummerChalenge = 108;
  SuperBlast     = 109;
  Terminator2    = 110;
  TestDrive3     = 111;
  TheAmazingSM   = 112;
  TheJorneyWest  = 113;
  TheLegendOfKy  = 114;
  TheSimpsonsSM  = 115;
  TongueOfFatman = 116;
  Toppler        = 117;
  TubularWorlds  = 118;
  VegasGambler   = 119;
  VikingChild    = 120;
  WC1Passwords   = 121;
  WC1SOPasswords = 122;
  WeirdDreams    = 123;
  WildScience    = 124;
  WingCommander1 = 125;
  WCommander1SO  = 126;
  WinterChalenge = 127;
  WolfPack       = 128;
  Wolfenstein3D  = 129;
  Wolfenstein3DF = 130;
  Xenon1CGA      = 131;
  Xenon1EGA      = 132;
  Xenon2         = 133;
  Xonix          = 134;
  ZanyGolf       = 135;

TYPE
  TUltra = OBJECT( TCorector )
    FUNCTION  GetText( Position: Integer ) : STRING; VIRTUAL;
    FUNCTION  Search( Key: Char ): Integer; VIRTUAL;
    FUNCTION  OpenFile( FileName: STRING ) : Boolean;
    FUNCTION  TestSize( Size: Longint ) : Boolean;
    FUNCTION  PromptBox : Boolean;
    PROCEDURE InfoBox( S: STRING; Alt: Boolean );
    PROCEDURE Corect;
    PROCEDURE ShowProgramLogo; VIRTUAL;
    PROCEDURE StartCorect( Position: Integer ); VIRTUAL;
    PROCEDURE InitCollection;
    DESTRUCTOR Done; VIRTUAL;
  END;

  PGameInfo = ^TGameInfo;
  TGameInfo = OBJECT( TObject )
         ID : Integer;   { Game ID }
       Name : PString;   { Game name }
       Func : PString;   { Corect function }
       FName: PString;   { File name }
       Size : LongInt;   { File size }
        CONSTRUCTOR Init
                     ( NewID: Integer;
                       NewName: STRING;
                       NewFunc: STRING;
                       NewFName: STRING;
                       NewSize: LongInt
                     );
        DESTRUCTOR Done; VIRTUAL;
  END;

  PDataCollection = ^TDataCollection;
  TDataCollection = OBJECT( TSortedCollection )
    FUNCTION KeyOf( Item: Pointer ) : Pointer; VIRTUAL;
    FUNCTION Compare( Key1, Key2: Pointer ) : Integer; VIRTUAL;
  END;

{ Global variables }
VAR
  DataInfo   : PDataCollection;
  AnEntry    : PGameInfo;
  GamFile    : FILE OF Byte;
  I,R        : Integer;

{-----------------------------------}
FUNCTION TDataCollection.KeyOf( Item: Pointer ) : Pointer;
BEGIN
  KeyOf := @PGameInfo( Item )^.ID;
END { TDataCollection.KeyOf };

{-----------------------------------}
FUNCTION TDataCollection.Compare( Key1, Key2: Pointer ) : Integer;
BEGIN
  IF Integer( Key1^ ) = Integer(Key2^ ) THEN
    Compare := 0
  ELSE
  IF Integer( Key1^ ) < Integer( Key2^ ) THEN
    Compare := -1
  ELSE
    Compare := 1;
END { TDataCollection.Compare };

{-----------------------------------}
CONSTRUCTOR TGameInfo.Init
             ( NewID: Integer;
               NewName: STRING;
               NewFunc: STRING;
               NewFName: STRING;
               NewSize: LongInt
             );

BEGIN
  ID   := NewID;
  Name := NewStr( NewName );
  Func := NewStr( NewFunc );
  FName:= NewStr( NewFName);
  Size := NewSize;
END { TGameInfo.Init };

{-----------------------------------}
DESTRUCTOR TGameInfo.Done;
BEGIN
  DisposeStr( Name );
  DisposeStr( Func );
  DisposeStr( FName );
END { TGameInfo.Done };
{------------------------------------------}

{---------------------------}
PROCEDURE TUltra.InfoBox( S: STRING; Alt: Boolean );
VAR
  OK  : PBCollection;
  Back: Byte;

BEGIN
  IF Alt THEN Back := 5 ELSE Back := 4;
  OK := New( PBCollection, Init( 1, 1 ) );
  OK^.Insert( New( PButton, Init('    OK    ', ' ', 21, 6, 0, Attr(Black, Back), 0, ButtonSelect )));
  MkWin( 15, 7, 52, 8, White, Back, True, CyrDouble, '[  ]');
  Writeln( #13#10 );
  Dec( TextAttr );
  WriteCStr( 52, False, S );
  OK^.Choose( 0 );
  Dispose( OK, Done );
  RmWin;
END;

FUNCTION TUltra.OpenFile( FileName: STRING ) : Boolean;
BEGIN
  OpenFile := True;
  Assign( GamFile, FileName);
  {$I-}
   Reset( GamFile );
  {$I+}
  IF IoResult <> 0 THEN
  BEGIN
    InfoBox('    ' + FileName, False );
    OpenFile := False;
  END;
END;

FUNCTION TUltra.TestSize( Size: Longint ) : Boolean;
VAR
  OK  : PBCollection;

BEGIN
  TestSize := True;
  IF FileSize( GamFile ) < Size THEN
  BEGIN
    OK := New( PBCollection, Init( 6, 1 ) );
    OK^.Insert( New( PButton, Init('    OK    ', ' ', 33, 18, 112, 64, 0, ButtonSelect )));
    MkWin(3, 3, 75, 20, White, Red, False, CyrDouble, Information);
    Dec( TextAttr );
    Writeln;
    Writeln;
    Writeln('      '+AnEntry^.FName^+'      ');
    Writeln('   .   ULTRA CORECTOR     ');
    Writeln('       ,     .    ');
    Writeln('          (UNPKL.COM,UNLZ.COM,');
    Writeln('   UNPACK.COM ).       .    -');
    Writeln('             .');
    Writeln;  Inc( TextAttr );
    Writeln('                    ',Size,' ');
    Writeln;  Dec( TextAttr );
    Writeln('             ,      ');
    Writeln('       .            !!!!');
    Writeln('    -   !   SUPER CORECTOR  ');
    Writeln('      ,      .');
    OK^.Choose( 0 );
    Dispose( OK, Done );
    RmWin;
    TestSize := False;
  END;
END;

FUNCTION TUltra.PromptBox : Boolean;
VAR YN: PBCollection;
BEGIN
  YN := New( PBCollection, Init( 2, 1 ) );
  YN^.Insert( New( PButton, Init('        ', ' ', 15, 10, ButtonFace, ButtonBack, 0, ButtonSelect )));
  YN^.Insert( New( PButton, Init('        ', ' ', 45, 10, ButtonFace, ButtonBack, 0, ButtonSelect )));
  AnEntry := DataInfo^.At( MenuPosition - 1 );
  MkWin(6, 6, 70, 12, White, DialogBack, True, CyrSingle,' '+AnEntry^.Name^+' ');
  PromptBox := False;
  Writeln;
  WriteCStr(70, True, ' ' + AnEntry^.Func^);
  Writeln;
  TextAttr := Attr(Yellow, DialogBack);
  WriteCStr(70, True, '    ' + AnEntry^.FName^ + ',    ');
  WriteCStr(70, True, ' , -     .');
  Writeln;
  TextAttr := Attr(White, DialogBack);
  WriteCStr(70, False, '       ?');
  YN^.Choose( 0 );
  IF NOT YN^.EscPressed AND (YN^.ButtonNumb = 0)
    THEN PromptBox := True
    ELSE PromptBox := False;
  RmWin;
END;

PROCEDURE TUltra.Corect;
CONST

  ForceData: ARRAY[1..45] OF Byte =
   ( $0A,$09,$0F,$47,$41,$4D,$45,$20,$49,$53,$20,$43,$52,
     $41,$43,$4B,$45,$44,$20,$42,$59,$20,$47,$56,$54,$20,
     $20,$50,$52,$45,$53,$53,$20,$45,$4E,$54,$45,$52,$2E,
     $2E,$2E,$0D,$10,$10,$0D );

  GsData: ARRAY[1..56] OF Byte =
   ( $90,$90,$55,$89,$E5,$57,$56,$06,$8B,$7E,$06,
     $89,$F1,$D1,$EE,$29,$DB,$01,$CE,$11,$DB,$89,
     $F0,$89,$DA,$50,$52,$BE,$0A,$00,$B9,$05,$00,
     $F7,$FE,$52,$31,$D2,$E2,$F9,$B9,$05,$00,$58,
     $04,$30,$AA,$E2,$FA,$5A,$58,$07,$5E,$5F,$5D,$CB );

  CommanderKeenData: ARRAY[1..34] OF Byte =
   ( $20,$20,$20,$20,$20,
     $47,$61,$6D,$65,$20,
     $49,$73,$20,
     $43,$72,$61,$63,$6B,$65,$64,$20,
     $42,$79,$20,$47,$56,$54,$20,$21,
     $20,$20,$20,$20,$20);

  RRData: ARRAY[1..25] OF Byte =
   ( $47,$61,$6D,$65,$20,$49,$73,$20,$43,$52,$41,$43,
     $4B,$45,$44,$20,$42,$79,$20,$47,$56,$54,$20,$21,$21 );

  F19Data : ARRAY[1..24] OF Byte =
   ( $90, $90, $90, $90, $90, $33, $C0, $8E,
     $D8, $BE, $84, $00, $0E, $07, $BF, $3B,
     $00, $AD, $AB, $AD, $AB, $B8, $B4, $FC );

  F1Data : ARRAY[1..18] OF Byte =
   ( $20,$43,$72,$61,$63,$6B,$65,$64,$20,
     $42,$79,$20,$47,$56,$54,$20,$21,$20 );

VAR Nop: Byte;
    S: STRING;
    Offset: Longint;
    A,B,C,D,E,F,J: Byte;

PROCEDURE WriteNop(Ofset: LongInt; Count: Byte);
BEGIN
  Seek(GamFile, Ofset);
  FOR I := 1 TO Count DO Write(GamFile, Nop);
END;

BEGIN
 Nop := $90;
 CASE MenuPosition OF
  AirborneRanger:
  BEGIN
   WriteNop( 25628, 4 );
   WriteNop( 28542, 4 );
   WriteNop( 35240, 4 );
   WriteNop( 35454, 4 );
   WriteNop( 25167, 4 );
  END;
  Aladdin:
  BEGIN
    WriteNop( 20392, 5 );
    WriteNop( 46127, 5 );
  END;
  ArcticAd1: WriteNop( 41030, 4 );
  Arcanoid1: WriteNop( 3995, 3 );
  Arcanoid2:
  BEGIN
   B := $EB;
   Seek(GamFile, 32615);  Write(GamFile, B);
  END;
  MonsterBash1:
  BEGIN
   WriteNop( 9420, 4 );
   WriteNop( 9665, 4 );
   WriteNop( 17730, 4 );
  END;
  BattleChess1: WriteNop( 32241, 3 );
  BattleChess4:
  BEGIN
    A := $C6;  B := $06;
    C := $55;  D := $91;
    E := $00;  F := $EB;
    Seek( GamFile, 126940 ); Write( GamFile, A,B,C,D,E,F );
  END;
  BadStreet: WriteNop( 2190, 4 );
  BioMenace1:
  BEGIN
   WriteNop( 41593, 4 );   WriteNop( 68372, 4 );
   WriteNop( 42013, 4 );   WriteNop( 71685, 4 );
   WriteNop( 53289, 4 );   WriteNop( 71780, 4 );
   WriteNop( 60829, 4 );   WriteNop( 71795, 4 );
  END;
  BlakeStone:
  BEGIN
   WriteNop( 96620, 4 );
   WriteNop( 146969, 4 );
  END;
  SuperBlast: WriteNop( 52192, 4 );
  Bushido:
  BEGIN
   B := $50;
   Seek(GamFile, 11296);  Write(GamFile, B, B);
  END;
  BubbleBobble:
  BEGIN
   WriteNop( 33827, 4 );
   WriteNop( 33847, 4 );
  END;
  Ironman: WriteNop( 7110, 2 );
  Jazz_Shareware:
  BEGIN
    A := $C6;
    B := $06;
    Seek( GamFile, 113880); Write(GamFile, A,B);
    Seek( GamFile, 195454); Write(GamFile, A,B);
  END;
  Cat:
  BEGIN
   WriteNop( 34318, 4 );
   WriteNop( 37334, 4 );
   WriteNop( 37614, 4 );
  END;
  Catacombs3D:
  BEGIN
   WriteNop( 46100, 4 );
   WriteNop( 46200, 4 );
   WriteNop( 46300, 4 );
  END;
  CrystalCaves1: WriteNop( 61076, 4 );
  CdMan:
  BEGIN
   A := $C7;  B := $06;
   C := $24;  D := $02;
   E := $04;  F := $00;
   J := $90;
   Seek(GamFile, 29853);  Write(GamFile, A,B,C,D,E,F,J);
  END;
  Civilization:
  BEGIN
   A := $F5;  B := $31;
   C := $C0;  D := $F9;
   E := $29;  F := $C0;
   Seek(GamFile, 266837);  Write(GamFile, A,B,C);
   Seek(GamFile, 267081);  Write(GamFile, D,E,F);
  END;
  ClydesAdvent:
  BEGIN
   WriteNop( 13231, 4 );
   WriteNop( 13891, 4 );
   WriteNop( 18835, 4 );
   WriteNop( 19358, 4 );
  END;
  CrimeWave:
  BEGIN
   B := $C6;  C := $06;
   D := $F5;  E := $3D;
   F := $03;
   WriteNop( 60576, 4 );
   Seek(GamFile, 60896);  Write(GamFile, B,C,D,E,F, Nop, Nop, Nop);
  END;
  DarkAges1: WriteNop( 21329, 4);
  DangerousDave1: WriteNop( 5617, 4 );
  DangerousDave2:
  BEGIN
   WriteNop( 9510, 4 );
   WriteNop( 16558, 4 );
  END;
  DawnRider:
  BEGIN
   WriteNop( 9785, 3 );
   WriteNop( 18355, 3 );
  END;
  DoubleDragon1:
  BEGIN
   WriteNop( 31624, 4 );
   WriteNop( 33929, 4 );
  END;
  DoubleDragon2:
  BEGIN
   WriteNop( 23440, 5 );
   WriteNop( 23453, 5 );
  END;
  DoubleDragon3:
  BEGIN
   WriteNop( 4929, 4 );
   WriteNop( 15985, 4 );
   WriteNop( 16043, 4 );
   WriteNop( 16073, 4 );
   WriteNop( 16107, 4 );
   WriteNop( 16130, 4 );
  END;
  DeathBringer: WriteNop( 600, 3 );
  DieHard: WriteNop( 43760, 2 );
  DIF2:
  BEGIN
   WriteNop( 3234, 4 );
   WriteNop( 3808, 4 );
   WriteNop( 4854, 4 );
   WriteNop( 7494, 4 );
  END;
  Dogfight: WriteNop( 188223, 3 );
  WeirdDreams: WriteNop( 1607, 2 );
  DragonStrike:
  BEGIN
   B := $32;
   Seek(GamFile, 39265);  Write(GamFile, B);
  END;
  DukeNukem1: WriteNop( 19598, 4 );
  DukeNukem3: WriteNop( 19477, 4 );
  DuckTales:
  BEGIN
   B := $09;
   C := $ED;
   Seek(GamFile, 67855);  Write(GamFile, B,C);
  END;
  Dune2:
  BEGIN
   B := $31;
   C := $C0;
   Seek(GamFile, 34030);  Write(GamFile, B,C);
  END;
  DynaBlaster: WriteNop( 32436, 4 );
  EyeOfTheBe1:
   BEGIN
   B := $EB;
   Seek(GamFile, 236630);  Write(GamFile, B);
  END;
  F117A:
  BEGIN
   B := $EB;
   C := $15;
   Seek(GamFile, 2773);  Write(GamFile, B,C);
  END;
  F15StrikeEag3: WriteNop( 1519, 2 );
  F19Stealth : { !!!! }
  BEGIN
   A := $58;
   B := $31;
   C := $C0;
   Seek(GamFile, 37661);   Write(GamFile, A,B,C);
   Close( GamFile );
   IF OpenFile('SU.EXE') THEN
   BEGIN
     IF TestSize(17600) THEN
     BEGIN
       Seek(GamFile, 11564);  FOR I := 1 TO 24 DO Write(GamFile, F19Data[I]);
     END ELSE Exit;
   END ELSE Exit;
  END; { !!!! }
  Formula1GP:
  BEGIN
   B := $EB;
   WriteNop( 105536, 2 );
   Seek(GamFile, 105541);  Write(GamFile, B);
   Seek(GamFile, 173471);  FOR I := 2 TO 15 DO Write(GamFile, F1Data[I]);
   Seek(GamFile, 173599);  FOR I := 1 TO 18 DO Write(GamFile, F1Data[I]);
   Seek(GamFile, 173736);  FOR I := 1 TO 18 DO Write(GamFile, F1Data[I]);
  END;
  TongueOfFatman: WriteNop( 2899, 3 );
  FlashBack:
  BEGIN
   WriteNop( 29156, 2 );
   WriteNop( 29159, 2 );
   WriteNop( 56157, 2 );
   WriteNop( 56160, 2 );
  END;
  SpecialForces:
  BEGIN
   B := $00;
   C := $20;
   Seek(GamFile,136222);
   FOR i:=1 TO 45 DO Write(GamFile, ForceData[I]);
   FOR i:=1 TO 94 DO Write(GamFile,C);
   Write(GamFile, B);
   FOR i:=1 TO 45 DO Write(GamFile, ForceData[I]);
   FOR i:=1 TO 84 DO Write(GamFile,C);
   Write(GamFile, B);
   FOR i:=1 TO 45 DO Write(GamFile, ForceData[I]);
   FOR i:=1 TO 86 DO Write(GamFile, C);
   FOR i:=1 TO 1482 DO Write(GamFile, B);
  END;
  Gauntlet2:
  BEGIN
   B := $FF;
   C := $7F;
   WriteNop( 8108, 5 );
   Seek(GamFile, 52776); Write(GamFile, B,C);
  END;
  Gods: WriteNop( 2762, 6 );
  GoldenAxe:
  BEGIN
   A := $CC;  B := $75;
   C := $74;  D := $FB;
   E := $BD;  F := $90;
   Seek(GamFile, 10);     Write(GamFile, A);
   Seek(GamFile, 32788);  Write(GamFile, B,D);
   Seek(GamFile, 32793);  Write(GamFile, C,D);
   Seek(GamFile, 37485);  Write(GamFile, F,F);
   Seek(GamFile, 41466);  Write(GamFile, C,D);
   Seek(GamFile, 41486);  Write(GamFile, B,D);
   Seek(GamFile, 41505);  Write(GamFile, C,D);
   Seek(GamFile, 54689);  Write(GamFile, B,D);
   Seek(GamFile, 54699);  Write(GamFile, C,D,E);
  END;
  GrandPrixU:
  BEGIN
   B:=$EB;
   Seek(GamFile, 10723);  Write(GamFile, B);
  END;
  Gremlins2:
  BEGIN
   B := $00;
   Seek(GamFile, 7429);  Write(GamFile, B);
  END;
  GunShip2000:
  BEGIN
   Seek(GamFile, 125330);
   FOR I := 1 TO 56 DO Write(GamFile, GsData[I]);
  END;
  Fury:
  BEGIN
    WriteNOP( 12947, 4 );
    WriteNOP( 30472, 4 );
  END;
  Galactix1:
  BEGIN
   WriteNop( 7841, 4 );
   WriteNop( 8124, 4 );
   WriteNop( 16294, 5 );
   WriteNop( 17667, 4 );
   WriteNop( 19088, 4 );
   WriteNop( 19099, 5 );
  END;
  Harald:
  BEGIN
   WriteNop( 2679, 4 );
   WriteNop( 2901, 4 );
   WriteNop( 2288, 4 );
   WriteNop( 2559, 2 );
   WriteNop( 2294, 3 );
   WriteNop( 22609, 4 );
   WriteNop( 1659, 4 );
  END;
  HardHatMack: WriteNop( 13708, 4 );
  Harrier:
  BEGIN
   B := $EB;
   WriteNop( 12899, 3 );
   Seek(GamFile, 12907);  Write(GamFile, B);
  END;
  Indiana500:
  BEGIN
   B := $EB;
   C := $1F;
   Seek(GamFile, 48633);  Write(GamFile, B,C);
  END;
  JumpMan: WriteNop( 87044, 4 );
  CommanderKeen1:
  BEGIN
   WriteNop( 33345, 4 );
   WriteNop( 16443, 4 );
  END;
  CommanderKeen2:
  BEGIN
   WriteNop( 33990, 4 );
   WriteNop( 27901, 4 );
  END;
  CommanderKeen3:
  BEGIN
   WriteNop( 30052, 4 );
   WriteNop( 36480, 4 );
  END;
  CommanderKeen4:
  BEGIN
   WriteNop( 37105, 4 );
   WriteNop( 68048, 4 );
  END;
  CommanderKeen5:
  BEGIN
   WriteNop( 37229, 4 );
   WriteNop( 66292, 4 );
  END;
  CommanderKeen6:
  BEGIN
   WriteNop( 36353, 4 );
   WriteNop( 64285, 4 );
  END;
  CKeen6Pass:
  BEGIN
   B := $EB;
   Seek(GamFile,124366);  Write(GamFile, B);
   Seek(GamFile,124389);  Write(GamFile, B);
   Seek(GamFile,224472);
   FOR I := 1 TO 34 DO Write(GamFile, CommanderKeenData[I]);
  END;
  CKeen6DemoVer:
  BEGIN
   WriteNop( 34252, 4 );
   WriteNop( 62014, 4 );
  END;
  Karateka: WriteNop( 17585, 6 );
  HeroesOfTheL:
  BEGIN
   B := $EB;
   C := $17;
   Seek(GamFile,66776);  Write(GamFile, Nop, Nop, Nop, B,C);
  END;
  HocusPocus: WriteNop( 69080, 4 );
  Lotus3:
  BEGIN
   B := $AF;
   Seek(GamFile,15622);  Write(GamFile, Nop, Nop, B, Nop);
   Seek(GamFile,239878); Write(GamFile, Nop, Nop, B, Nop);
  END;
  LHXAttackC:
  BEGIN
   B := $EB;
   Seek(GamFile,2565);  Write(GamFile, B);
  END;
  Luigi:
  BEGIN
   B := $00;
   Seek(GamFile, 1404);  Write(GamFile, B);
  END;
  IntoTheEagle:
  BEGIN
   WriteNop( 11210, 4 );
   WriteNop( 11404, 4 );
   WriteNop( 11493, 4 );
  END;
  MajorStriker:
  BEGIN
   WriteNop( 43866, 4 );
   WriteNop( 42963, 4 );
  END;
  Menace:
  BEGIN
   B := $EB;
   Seek(GamFile, 1042);   Write(GamFile, B);
  END;
  MoonStone:
  BEGIN
   A := $C6;  B := $44;
   C := $30;  D := $03;
   E := $EB;
   Seek(GamFile,1949);  Write(GamFile, E);
   Seek(GamFile,3293);  Write(GamFile, A,B,C,D);
  END;
  Motocross: WriteNop( 1765, 3 );
  MechWarrior: WriteNop( 7418, 3 );
  MegaloMania: WriteNop( 31430, 2 );
  NBA:
  BEGIN
   B := $EB;
   WriteNop( 1330, 3 );
   Seek(GamFile, 1338);  Write(GamFile, B);
  END;
  ShadowKnights:
  BEGIN
   WriteNop( 13157, 4 );
   WriteNop( 16467, 4 );
  END;
  AvoidTheNoid:
  BEGIN
   WriteNop( 7127, 4 );
   WriteNop( 12242, 4 );
  END;
  OutRun_CGA: WriteNop( 15374, 4 );
  PacMan:
  BEGIN
   B := $0D;
   Seek(GamFile, 767);  Write(GamFile, B);
  END;
  Popcorn: WriteNop( 80671, 4 );
  PinballDream: WriteNop( 7287, 4 );
  Pila:
  BEGIN
   WriteNop( 5998, 4 );
   WriteNop( 7063, 4 );
   WriteNop( 9597, 4 );
   WriteNop( 10337, 4 );
   WriteNop( 12115, 4 );
   WriteNop( 12855, 4 );
   WriteNop( 13377, 4 );
   WriteNop( 13816, 4 );
   WriteNop( 16474, 4 );
   WriteNop( 22334, 4 );
   WriteNop( 22630, 4 );
  END;
  StripPoker3: WriteNop( 3521, 10 );
  StreetRod:
  BEGIN
    A := $00;  B := $7D;
    Seek(GamFile, 22711);  Write(GamFile, A, B);
  END;
  StreetRod2:
  BEGIN
    A := $00;  B := $7D;
    Seek(GamFile, 22062);  Write(GamFile, A, B);
  END;
  Predator2: WriteNop( 22257, 4 );
  Raptor:
  BEGIN
   A := $00;  B := $94;
   C := $35;  D := $77;
   Seek(GamFile, 276925);  Write(GamFile, A,B,C,D);
  END;
  RealmsOfChaos:
  BEGIN
    A := $EB;
    Seek(GamFile, 24928 );  Write(GamFile, A );
    WriteNop( 49366, 4 );
  END;
  RexNebular:
  BEGIN
    B := $EB;
    Seek(GamFile, 430631);  Write(GamFile, B);
  END;
  RickDangerous2:
  BEGIN
   WriteNop( 27359, 4 );
   WriteNop( 35869, 4 );
   WriteNop( 36014, 4 );
  END;
  RailroadTycoon:
  BEGIN
   B := $89;
   C := $EB;
   Seek(GamFile, 83159);
   FOR I := 1 TO 25 DO Write(GamFile, RRData[I]);
   Seek(GamFile, 181812);  Write(GamFile, B);
   Seek(GamFile, 181815);  Write(GamFile, C);
  END;
  Rocketeer: WriteNop( 68920, 3 );
  SecretAgent1:   WriteNop( 11440, 4 );
  SimCity:
  BEGIN
   A := $00;  B := $94;
   C := $35;  D := $77;
   Seek(GamFile, 170469);  Write(GamFile, A,B,C,D, A,B,C,D, A,B,C,D);
  END;
  SimCityPass:
  BEGIN
   B := $EB;
   Seek(GamFile,134850);  Write(GamFile, B);
  END;
  SimCity2000:
  BEGIN
   A := $00;  B := $94;
   C := $35;  D := $77;
   Seek(GamFile, 672780);  Write(GamFile, A,B,C,D);
   Seek(GamFile, 672795);  Write(GamFile, A,B,C,D);
   Seek(GamFile, 672810);  Write(GamFile, A,B,C,D);
  END;
  SimEarth:
  BEGIN
   B := $EB;
   C := $31;
   Seek(GamFile,69896);   Write(GamFile, B);
   Seek(GamFile,113342);  Write(GamFile, C);
  END;
  TheSimpsonsSM:
  BEGIN
   WriteNop( 13783, 4 );
   WriteNop( 33960, 4 );
  END;
  TheAmazingSM:
  BEGIN
   b:=$EB;
   Seek(GamFile, 184756);  Write(GamFile, Nop, Nop, Nop);
   Seek(GamFile, 185571);  Write(GamFile, B);
  END;
  TheJorneyWest:
  BEGIN
    WriteNop( 28905, 4 );
    WriteNop( 29278, 4 );
  END;
  StormLordVGA: WriteNop( 1671, 5 );
  StormLordCGA: WriteNop( 1773, 5 );
  SecretWeapons:
  BEGIN
   B := $01;
   Seek(GamFile,39244);   Write(GamFile, B);
  END;
  TestDrive3:
  BEGIN
   WriteNop( 30785, 2 );
   WriteNop( 30836, 2 );
   WriteNop( 30888, 2 );
  END;
  Terminator2:
  BEGIN
   WriteNop( 12426, 3 );
   WriteNop( 14340, 3 );
   WriteNop( 15278, 3 );
   WriteNop( 15473, 3 );
   WriteNop( 16638, 3 );
   WriteNop( 16942, 3 );
   WriteNop( 18756, 3 );
  END;
  TheLegendOfKy:
  BEGIN
    B := $EB;
    Seek(GamFile, 257063); Write(GamFile, B);
  END;
  TubularWorlds:
  BEGIN
    WriteNop( 5032, 4 );
    WriteNop( 5075, 4 );
  END;
  Toppler: WriteNop( 24484, 1 );
  VegasGambler:
  BEGIN
   B := $00;
   C := $7D;
   Seek(GamFile, 55134);  Write(GamFile, B,C);
  END;
  VikingChild:
  BEGIN
   WriteNop( 21431, 2 );
   WriteNop( 21446, 8 );
   WriteNop( 26524, 2 );
  END;
  Wolfenstein3D:
  BEGIN
   WriteNop( 79906, 4 );
   WriteNop( 83306, 4 );
  END;
  Wolfenstein3DF:
  BEGIN
   WriteNop( 83658, 4 );
   WriteNop( 87115, 4 );
  END;
  WingCommander1:
  BEGIN
   A := $00;  B := $7D;
   C := $01;  D := $00;
   Offset := 96329;
   Seek(GamFile, Offset);
   FOR I := 1 TO 14 DO
   BEGIN
    IF I <= 9 THEN Write(GamFile, A,B, A,B) ELSE Write(GamFile, C,D,C,D);
    Inc(Offset, 111);
    Seek(GamFile, Offset);
   END;
  END;
  WC1Passwords:
  BEGIN
   A := $FF;  B := $00;
   C := $EB;  D := $90;
   Seek(GamFile, 98046);   Write(GamFile, A,B, A,B, A,B);
   Seek(GamFile, 287434);  Write(GamFile, C);
   Seek(GamFile, 301368);  Write(GamFile, D,D,D,D,D,D,C);
  END;
  WCommander1SO:
  BEGIN
   A := $00;  B := $7D;
   C := $01;  D := $00;
   Offset := 97671;
   Seek(GamFile, Offset);
   FOR I := 1 TO 14 DO
   BEGIN
    IF I <= 9 THEN Write(GamFile, A,B,A,B) ELSE Write(GamFile, C,D,C,D);
    Inc(offset, 111);
    Seek(GamFile, Offset);
   END;
  END;
  WC1SOPasswords:
  BEGIN
   A := $FF;  B := $00;
   C := $EB;  D := $90;
   Seek(GamFile, 99277);   Write(GamFile, A,B,A,B,A,B);
   Seek(GamFile, 290138);  Write(GamFile, C);
   Seek(GamFile, 304015);  Write(GamFile, D,D,D,D,D,D,C);
  END;
  WinterChalenge: WriteNop( 1225628, 3 );
  SummerChalenge: WriteNop( 1303714, 3 );
  WildScience:
  BEGIN
   B := $C8;
   Seek(GamFile, 209102);  Write(GamFile, B);
   Seek(GamFile, 214377);  Write(GamFile, B);
  END;
  CrusadersOf:
  BEGIN
   B := $74;
   Seek(GamFile, 26243);  Write(GamFile, B);
  END;
  WolfPack:
  BEGIN
   A := $C6;
   B := $06;
   C := $EB;
   Seek(GamFile, 111407);  Write(GamFile, A,B);
   Seek(GamFile, 111412);  Write(GamFile, C);
  END;
  Xenon1CGA, Xenon1EGA:
  BEGIN
    WriteNop( 2181, 4 );
    WriteNop( 3378, 4 );
  END;
  Xenon2:
  BEGIN
   A := $C3;
   Seek(GamFile, 17487);  Write(GamFile, A);
  END;
  Xonix:
  BEGIN
   A := $90;
   Seek(GamFile, 6553);  Write(GamFile, A);
  END;
  ZanyGolf:
  BEGIN
   A := $E9;
   B := $74;
   C := $01;
   Seek(GamFile,62684);  Write(GamFile, A,B,C);
  END;
 END;
 InfoBox('  !', True );
 Close(GamFile);
END;

PROCEDURE TUltra.InitCollection;

  PROCEDURE g( ID: Integer;
               Name: STRING;
               Func: STRING;
               FName: STRING;
               Size: LongInt
             );
  BEGIN
    WITH DataInfo^ DO
      Insert( New( PGameInfo, Init( ID, Name, Func, FName, Size )));
  END;

BEGIN
  DataInfo := New( PDataCollection, Init( 50, 10 ) );
  g( AirborneRanger,'Airborne Ranger', Every, 'AR.EXE', 73000 );
  g( Aladdin,       'Aladdin', Lifes+_I+'', 'ALADDIN.EXE', 156000 );
  g( Arcanoid1,     'Arcanoid 1 (CGA Version)', '', 'ARK.COM', 37000 );
  g( Arcanoid2,     'Arcanoid 2 - Revenge Of DOH', Lifes, 'REVOFDOH.DAT', 74000 );
  g( ArcticAd1,     'Arctic Adventure 1', Bull, 'AA1.EXE', 147000 );
  g( AvoidTheNoid,  'Avoid The Noid', Lifes+_I+Bombs, 'NOID.EXE', 77000 );
  g( BadStreet,     'Bad Street Brawler', Lifes, 'START.EXE', 45000 );
  g( BattleChess1,  'Battle Chess', PassW, 'CH.EXE', 83400 );
  g( BattleChess4,  'Battle Chess 4000', PassW, 'BC4000.EXE', 245000 );
  g( BioMenace1,    'BioMenace 1', Every, 'BMENACE1.EXE', 235000 );
  g( BlakeStone,    'Blake Stone', Lifes, 'BS_AOG.EXE', 299000 );
  g( BubbleBobble,  'Bubble Bobble', Lifes, 'BUBBOB.DAT', 71000 );
  g( Bushido,       'Bushido', Lifes, 'BUSHIDO.EXE', 72000 );
  g( Cat,           'Cat', Lifes, 'CAT.EXE', 55000 );
  g( Catacombs3D,   'Catacombs 3D', Every, 'CAT3D.EXE', 191000 );
  g( CdMan,         'Cd-Man', Live, 'CD-MAN.EXE', 33900 );
  g( Civilization,  'Civilization', PassW, 'CIV.EXE', 304000 );
  g( ClydesAdvent,  'Clyde''s Adventure', Enrgy, 'CLYDE.EXE', 117000 );
  g( CommanderKeen1,'Commander Keen 1', LAndB, 'KEEN1.EXE', 100000 );
  g( CommanderKeen2,'Commander Keen 2', LAndB, 'KEEN2.EXE', 118000 );
  g( CommanderKeen3,'Commander Keen 3', LAndB, 'KEEN3.EXE', 127000 );
  g( CommanderKeen4,'Commander Keen 4', LAndB, 'KEEN4.EXE', 258000 );
  g( CommanderKeen5,'Commander Keen 5', LAndB, 'KEEN5.EXE', 261000 );
  g( CommanderKeen6,'Commander Keen 6', LAndB, 'KEEN6.EXE', 266000 );
  g( CKeen6Pass,    'Commander Keen 6 ()', PassW, 'KEEN6.EXE', 266000 );
  g( CKeen6DemoVer, 'Commander Keen 6 (Demo)', LAndB, 'KEEN6.EXE',  236000 );
  g( CrimeWave,     'Crime Wave', Lifes+_I+'', 'CC02.EXE', 94000 );
  g( CrusadersOf,   'Crusaders Of The Dark Savant (Wizardy)', PassW, 'VBASE.OVR', 1 );
  g( CrystalCaves1, 'Crystal Caves 1', Bull, 'CC1.EXE', 191000 );
  g( DIF2,          'DIF - 2', Live, 'DIF-2.EXE', 66000 );
  g( DangerousDave1,'Dangerous Dave', Lifes, 'DAVE.EXE', 172000 );
  g( DangerousDave2,'Dangerous Dave 2', LAndB, '1.EXE', 215000 );
  g( DarkAges1,     'Dark Ages 1', Live, 'DA1.EXE', 150000 );
  g( DawnRider,     'Dawn Rider', Live, 'DR.EXE', 113000 );
  g( DeathBringer,  'Death Bringer', PassW, 'DB.EXE', 20000 );
  g( DieHard,       'Die Hard', PassW, 'DIE.EXE', 1 );
  g( Dogfight,      'Dog Fight', PassW, 'DOG1.EXE', 274000 );
  g( DoubleDragon1, 'Double Dragon 1', '', 'DDMAIN.EXE', 132000 );
  g( DoubleDragon2, 'Double Dragon 2', Live, 'DRAGON.EXE', 82000 );
  g( DoubleDragon3, 'Double Dragon 3', Live, 'DD3.EXE', 89000 );
  g( DragonStrike,  'Dragon Strike', PassW, 'MAIN.EXE', 60000 );
  g( DuckTales,     'Duck Tales', PassW, 'DUCKTALE.EXE', 165000 );
  g( DukeNukem1,    'Duke Nukem 1', Live, 'DN1.EXE', 124000 );
  g( DukeNukem3,    'Duke Nukem 3', Live, 'DN3.EXE', 124000 );
  g( Dune2,         'Dune 2', PassW, 'DUNE2.EXE', 350000 );
  g( DynaBlaster,   'Dyna Blaster', '', 'DYNA.EXE', 93000 );
  g( EyeOfTheBe1,   'Eye Of The Beholder 1', PassW, 'EOB.EXE', 264000 );
  g( F117A,         'F117A Stealth Fighter', PassW, 'START.EXE', 90000 );
  g( F15StrikeEag3, 'F15 Strike Eagle 3', PassW, 'LOAD.EXE', 9500 );
  g( F19Stealth,    'F19 Stealth Figther', PassW, 'START.EXE', 87000 );
  g( FlashBack,     'Flash Back', PassW, 'FB.EXE', 126000 );
  g( Formula1GP,    'Formula 1 Grand Prix', PassW, 'F1GP.EXE', 332000 );
  g( Fury,          'Fury Of The Furries', Lifes+_I+'','FURY.EXE', 579000 );
  g( Galactix1,     'Galactix 1', Every, 'GX1.EXE', 76000 );
  g( Gauntlet2,     'Gauntlet 2', PassW+_I+Live, 'GAUNTLET.EXE', 81000 );
  g( Gods,          'Gods', Lifes, 'GAME.EXE', 152000 );
  g( GoldenAxe,     'Golden Axe', PassW, 'AXE.DAT', 115000 );
  g( GrandPrixU,    'Grand Prix Unlimited', PassW, 'GPU.EXE', 174000 );
  g( Gremlins2,     'Gremlins 2', Lifes, 'GREMLINS.EXE', 110000 );
  g( GunShip2000,   'Gunship 2000', PassW, 'GS.GS2', 165000 );
  g( Harald,        'Harald', Every, 'HARALD.EXE', 81000 );
  g( HardHatMack,   'HardHatMack', Lifes, 'HM.COM', 42000 );
  g( Harrier,       'Harrier', PassW, 'HARIER.EXE', 66000 );
  g( HeroesOfTheL,  'Heroes Of The Lance', PassW, 'START.EXE', 97000 );
  g( HocusPocus,    'Hocus Pocus', Live, 'HOCUS.EXE', 181000 );
  g( Indiana500,    'Indianapolis 500', PassW, 'INDY.EXE', 159000 );
  g( IntoTheEagle,  'Into The Eagle''s Nest', Every, 'MAIN.EXE', 36000 );
  g( Ironman,       'Ironman', '', 'GAME.EXE', 76200 );
  g( Jazz_Shareware,'Jazz Jackrabbit (Shareware)', Enrgy, 'JAZZ.EXE', 226000 );
  g( JumpMan,       'Jump Man (Shareware)', Live, 'JMAN.EXE', 186000 );
  g( Karateka,      'Karateka', '  ', 'KARATEKA.EXE', 87000 );
  g( LHXAttackC,    'LHX Attack Chopper', PassW, 'LHX.EXE', 279000 );
  g( Lotus3,        'Lotus 3', PassW, 'LOTUS.DAT', 1 );
  g( Luigi,         'Luigi', Lifes, 'LUIGI.EXE', 83000 );
  g( MajorStriker,  'Major Stryker', Lifes+_I+Bombs, 'MAJOR.EXE', 219000 );
  g( MechWarrior,   'Mech Warrior', PassW, 'MW_MAIN.EXE', 137000 );
  g( MegaloMania,   'MegaloMania', PassW, 'MEGA.EXE', 76000 );
  g( Menace,        'Menace', Live, 'MENACE.EXE', 79000 );
  g( MonsterBash1,  'Monster Bash 1', Lifes, 'BASH1.EXE', 154000 );
  g( MoonStone,     'Moonstone', Lifes+_I+'', 'MAIN.EXE', 178000 );
  g( Motocross,     'Motocross', PassW, 'MOTO.EXE', 134000 );
  g( NBA,           'Lacers Vs Seltgs (NBA)', PassW, 'NBA.EXE', 178000 );
  g( OutRun_CGA,    'Out Run (CGA VERSION)', '', 'OUTCGA.EXE', 66000 );
  g( PacMan,        'Pac-Man', Lifes, 'PAC-MAN.EXE', 18000 );
  g( Pila,          'Pila', Lifes, 'PILA.EXE', 51000 );
  g( PinballDream,  'Pinball Dreams', Balls, 'PD.EXE', 519000 );
  g( Popcorn,       'Popcorn', Balls, 'POPCORN.EXE', 103000 );
  g( Predator2,     'Predator 2', Live, 'PRED.EXE', 132000 );
  g( RailroadTycoon,'Railroad Tycoon', PassW, 'GAME.EXE', 197000 );
  g( Raptor,        'Raptor', Money, 'RAP.EXE', 411000 );
  g( RealmsOfChaos, 'Realms Of Chaos', Live+_I+Magic, 'ROC1.EXE', 141000 );
  g( RexNebular,    'Rex Nebular', PassW, 'NEBULAR.EXE', 480000 );
  g( RickDangerous2,'Rick Dangerous 2', Every, 'MAIN.EXE', 55000 );
  g( Rocketeer,     'Rocketeer', PassW, 'ROCKET.EXE', 94000 );
  g( SecretAgent1,  'Secret Agent 1', Bull, 'SAM1.EXE', 199000 );
  g( SecretWeapons, 'Secret WeaponsOf The Luftwaffe', PassW, 'NOTCAMP.OVL', 1 );
  g( ShadowKnights, 'Shadow Knights', Lifes+_I+Magic, 'NIN.EXE', 89000 );
  g( SimCity,       'SimCity', Money, 'SIMCITY.EXE', 190000 );
  g( SimCity2000,   'SimCity 2000', Money, 'SC2000.EXE', 1 );
  g( SimCityPass,   'SimCity - ', PassW, 'SIMCITY.EXE', 190000 );
  g( SimEarth,      'SimEarth', PassW, 'SIMEARTH.EXE', 406000 );
  g( SpecialForces, 'Special Forces', PassW, 'SFORCES.EXE', 1 );
  g( StormLordCGA,  'StormLord (CGA)', Lifes, 'CGA.EXE', 43000 );
  g( StormLordVGA,  'StormLord (EGA/VGA)', Lifes, 'EGA_VGA.EXE', 51000 );
  g( StreetRod,     'Street Rod', Money, 'SR.EXE', 259000 );
  g( StreetRod2,    'Street Rod 2', Money, 'SR2.EXE', 264000 );
  g( StripPoker3,   'Strip Poker 3', PassW, 'POKER.EXE', 158000 );
  g( SummerChalenge,'Summer Challenge', PassW, 'SUMMER.EXE', 1442000 );
  g( SuperBlast,    'Super Blast', Lifes, 'BLAST.EXE', 123000 );
  g( Terminator2,   'Terminator 2', Live, 'TERM2.EXE', 52000 );
  g( TestDrive3,    'Test Drive 3', Lifes, 'TD3.EXE', 137000 );
  g( TheAmazingSM,  'The Amazing Spiderman', PassW+_I+Live, 'SPIDEY.EXE', 231000 );
  g( TheJorneyWest, 'The Jorney To The West', '', 'WEST.EXE', 64000 );
  g( TheLegendOfKy, 'The Legend Of Kyrandia', PassW, 'MAIN.EXE', 274000 );
  g( TheSimpsonsSM, 'The Simpsons Space Mutants', Live, 'SIMPSONS.EXE', 130000 );
  g( TongueOfFatman,'Tongue Of Fatman', PassW, 'FATMAN.EXE', 86000 );
  g( Toppler,       'Toppler (Perestroika)', Lifes, 'TOPPLER.EXE', 75000 );
  g( TubularWorlds, 'Tubular Worlds', Lifes+'  PLAYER 1', 'PART2.EXE', 116000 );
  g( VegasGambler,  'Vegas Gambler', Money, 'VEGAS.EXE', 59000 );
  g( VikingChild,   'Viking Child', Live, 'VC.EXE', 61000 );
  g( WC1Passwords,  'Wing Commander 1', PassW, 'WC.EXE', 302000 );
  g( WC1SOPasswords,'Wing Commander 1 (Secret Operations)', PassW, 'SO.EXE', 305000 );
  g( WCommander1SO, 'Wing Commander 1 (Secret Operations)', Shild, 'SO.EXE', 305000 );
  g( WeirdDreams,   'Weird Dreams', PassW, 'WEIRD.EXE', 70000 );
  g( WildScience,   'Wild Science Arcade ( Edison )', Lifes, 'EDISON.EXE', 527000 );
  g( WingCommander1,'Wing Commander 1', Shild, 'WC.EXE', 302000 );
  g( WinterChalenge,'Winter Challenge', PassW, 'WINTER.EXE', 2098000 );
  g( WolfPack,      'Wolfpack', PassW, 'WOLFPACK.EXE', 141000 );
  g( Wolfenstein3D, 'Wolfenstein 3D (Shareware)', Enrgy+_I+Bull, 'WOLF3D.EXE', 296000 );
  g( Wolfenstein3DF,'Wolfenstein 3D', Enrgy+_I+Bull,'WOLF6E.EXE',297000);
  g( Xenon1CGA,     'Xenon 1 (CGA)', Lifes+_I+Enrgy, 'XENCGA', 139000 );
  g( Xenon1EGA,     'Xenon 1 (EGA)', Lifes+_I+Enrgy, 'XENEGA', 139000 );
  g( Xenon2,        'Xenon 2', Enrgy, 'XENON2.EXE', 123000 );
  g( Xonix,         'Xonix', Lifes, 'XONIX.EXE', 8500 );
  g( ZanyGolf,      'Zany Golf', PassW, 'ZANY.COM', 63000 );
  MaxGames := DataInfo^.Count;
END;

PROCEDURE TUltra.ShowProgramLogo;
BEGIN
  MkWin(9, 3, 64, 19, White, Blue, True, CyrSingle, '');
  Dec( TextAttr );
  Writeln;
  Writeln;
  Writeln('                     ');
  Writeln('                    ');
  Writeln('                          ');
  Writeln('                      ');
  Writeln('                        ');
  Writeln('                      ');
  Writeln('           ');
  Writeln('       ');
  Writeln('          ');
  Writeln('    ');
  Writeln('                   ');
  Writeln('          ');
  Writeln('                ');
  Writeln('       ');
  Writeln('               ');
  Writeln('                   ' + ProgramVer +'  ');
  Write(  '                        ');
  FBox(34, 19, 49, 21, White, Red, CyrDouble );
  WriteBetween( 34, 49, 20, White, Red, ProgramVer);
  Pause;
  RmWin;
END;

FUNCTION TUltra.GetText( Position: Integer ) : STRING;
BEGIN
  AnEntry := DataInfo^.At( Position );
  GetText := AnEntry^.Name^;
END;

FUNCTION TUltra.Search( Key: Char ): Integer;
VAR
  Tmp     : Word;
  FoundIt : Boolean;
  TmpEntry: PGameInfo;

BEGIN
  FoundIt := False;
  FOR Tmp := 0 TO DataInfo^.Count - 1 DO
  BEGIN
    TmpEntry := DataInfo^.At( Tmp );
    IF Key = TmpEntry^.Name^[1] THEN
    BEGIN
      FoundIt := True;
      Break;
    END;
  END;
  IF FoundIt
    THEN Search := Tmp + 1
    ELSE Search := -1;
END;

PROCEDURE TUltra.StartCorect;
VAR AnEntry: PGameInfo;
BEGIN
  AnEntry := DataInfo^.At( MenuPosition - 1 );
  IF (PromptBox) AND (OpenFile(AnEntry^.FName^))
   THEN IF TestSize(AnEntry^.Size) THEN Corect;
END;

DESTRUCTOR TUltra.Done;
BEGIN
  Dispose( DataInfo, Done );
END;

VAR
  Ultra: TUltra;

BEGIN
  Ultra.Init('ULTRA CORECTOR', ' 2.1');
  Ultra.InitCollection;
  Ultra.Run;
END.